///File : HangMan.hpp
//------------------------------------------------------------------------------
/*
    This file is part of HangMan.

    HangMan is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    HangMan is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with HangMan.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
//------------------------------------------------------------------------------
#include <wx/sound.h>

//------------------------------------------------------------------------------
#include "config.hpp"
#include "LetterGameBase.hpp"

//------------------------------------------------------------------------------

#if not defined HANG_MAN_HPP_LETTER_GAMES
#define HANG_MAN_HPP_LETTER_GAMES
//------------------------------------------------------------------------------

#define HANGMAN_NB_CHANCE 7

#if defined(__WXMSW__)
    #define UNKNOWN_LETTER _T("*")
#else
    #define UNKNOWN_LETTER _T("~")
#endif

class HangMan : public LetterGameBase
{
public:
    HangMan();
    void NewWord();

    bool TryLetter(const wxChar &letter);
    bool TryLetters(const wxString &letters); // Try a list of letter

    wxString GetCurrentWordResult() const;
    wxString GetCurrentWord() const;
    wxString GetTriedLetters() const;

    bool IsWon() const;
    bool IsLost() const;

    void SetTryFirstLastLetters(const bool &tryLetters);
    bool IsTryFirstLastLetters() const;

    int GetNbSucceededWords() const;
    int GetNbPlayedWords() const;

    int GetChanceLeft() const;
    int GetChanceUsed() const;

protected:
    wxString m_currentWordResult;
    wxString m_currentWord;

    wxString m_triedLetters;

    int m_chanceUsed, m_nbSucceededWords, m_nbPlayedWords;

    bool m_tryFirstLastLetters;
};

#endif //HANG_MAN_HPP_LETTER_GAMES
